local MinBuild, MaxBuild, Build = 40000, 0, select(4, GetBuildInfo())
if Build < MinBuild or ( MaxBuild > 0 and Build > MaxBuild ) then return end

local AddonName, AddonTable = ...
local s = SpellFlashAddon
local c = BittensSpellFlashLibrary
AddonTable.Spells = {}
local spells = AddonTable.Spells

------------------------------------------------------------------------- common
spells["Power Word: Fortitude"] = {
	SpellID = 21562,
}

spells["Shadow Protection"] = {
	SpellID = 27683,
}

spells["Shadowfiend"] = {
	SpellID = 34433,
	Optional = true,
}

spells["Inner Fire"] = {
	SpellID = 588,
	Buff = "Inner Fire",
	BuffUnit = "player",
}

------------------------------------------------------------------------- shadow
spells["Shadow Word: Death"] = {
	SpellID = 32379,
	ExtraCheck = function()
		return s.HealthPercent() <= 25
			or s.PowerPercent("player") < 50
	end
}

spells["Vampiric Touch"] = {
	SpellID = 34914,
	MyDebuff = "Vampiric Touch",
	EarlyRefresh = 2,
	ExtraCheck = function()
		return not s.Casting("Vampiric Touch", "player")
	end
}

spells["Devouring Plague"] = {
	SpellID = 2944,
	MyDebuff = "Devouring Plague",
	EarlyRefresh = 2,
}

spells["Shadow Word: Pain"] = {
	SpellID = 589,
	MyDebuff = "Shadow Word: Pain",
}

spells["Mind Blast"] = {
	SpellID = 8092,
	CastTimeAndCooldown = true,
}

spells["Mind Blast at 3 Orbs"] = {
	SpellID = 8092,
	CastTimeAndCooldown = true,
	ExtraCheck = function()
		return s.BuffStack("Shadow Orb", "player") == 3
	end
}

spells["Empowered Shadow"] = {
	SpellID = 8092,
	Buff = "Empowered Shadow",
	BuffUnit = "player",
	EarlyRefresh = 1.5,
	RequiresBuff = "Shadow Orb",
	CastTimeAndCooldown = true,
}

spells["Mind Flay"] = {
	SpellID = 15407,
}

spells["Dark Evangelism"] = {
	SpellID = 15407,
	Buff = "Dark Evangelism",
	BuffUnit = "player",
	Stack = 5,
}

spells["Mind Flay for Empowered Shadow"] = {
	SpellID = 15407,
	ExtraCheck = function()
		return not s.Buff("Empowered Shadow", "player")
			and not s.Casting("Mind Blast", "player")
	end
}

spells["Shadowform"] = {
	SpellID = 15473,
	Buff = "Shadowform",
	BuffUnit = "player",
}

spells["Dispersion"] = {
	SpellID = 47585,
}

spells["Dark Archangel"] = {
	SpellID = 87151,
	NoGCD = true,
	Optional = true,
	ExtraCheck = function()
		return s.BuffStack("Dark Evangelism", "player") == 5
	end
}

spells["Vampiric Embrace"] = {
	SpellID = 15286,
	Buff = "Vampiric Embrace",
	BuffUnit = "player",
}

spells["Dispursion"] = {
	SpellID = 47585,
	ExtraCheck = function()
		return s.PowerPercent("player") < 64
	end
}

-- AddonTable.Castable["English_Spell_Name"] = function()
	-- wipe(z)
	-- z.SpellID = GlobalSpellID--[[English_Spell_Name]]   --this is for defining the correct name of the spell
	-- z.DebuffSlotNeeded = 1   --use this if you want to make sure that a debuff slot is free on the target so that you do not replace other debuffs
	-- z.Debuff = z.SpellID   --place debuff name or table of names here if the spell has a debuff that may only be on a target once in total from everyone and has a cooldown shorter than the debuff duration
	-- z.MyDebuff = z.SpellID   --place debuff name or table of names here if the spell has a debuff that may be on the target multiple times by many people and has a cooldown shorter than the debuff duration
	-- z.Buff = z.SpellID   --place buff name or table of names here if the spell has a buff that may only be on yourself once in total from everyone and has a cooldown shorter than the buff duration
	-- z.MyBuff = z.SpellID   --place buff name or table of names here if the spell has a buff that may be on the target multiple times by many people and has a cooldown shorter than the buff duration
	-- z.BuffUnit = "player"   --you will need to use this if the buff or debuff is not applied to your target
	-- z.Stack = 2   --use this if the buff or debuff requires more than one application
	-- z.EarlyRefresh = 5   --use this to indicate the buff or debuff early for a desired number of seconds
	-- z.CastTime = s.CastTime(z.SpellID)   --use this only if you want to replace the spell cast time used for early indication of a buff or debuff
	-- z.EnemyTargetNeeded = 1   --use this if the spell should have an enemy targeted
	-- z.TargetThatUsesManaNeeded = 1   --use this if the spell is only useful on a target that uses mana such as mana draining spells
	-- z.NoRangeCheck = 1   --use this to disable range detection if the spell has a limited range but the detection in this function is not working correctly for the particular spell
	-- z.NotIfActive = 1   --use this if the spell may be toggled on such as auto attack or on next swing spells, or to disable when casting or channeling, or if the spell has a cooldown
	-- z.NotWhileMoving = 1   --use this if the spell is not able to be cast while moving
	-- z.NoPowerCheck = 1   --use this to disable the power checking in this function
	-- z.EvenIfNotUsable = 1   --use this to disable the usability checking in this function and may be used if currently in the process of completing a prerequisite that will make the spell usable
	-- z.Unit = "target"   --this should not be used unless the spell is not to be cast on the target
	-- z.Interrupt = 1   --use this if the target should be casting or channeling an interruptible ability
	-- return s.CheckIfSpellCastable(z)
-- end
